package com.qizhen.spider.ai;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.http.Method;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.springframework.util.CollectionUtils;
import org.springframework.web.client.RestTemplate;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.*;

public class QizhenAssistant {

    public static String getChatResponse(String userInput, String conversationId) {
        int retry = 0;
        try {
           return getAnswer(userInput, conversationId);
        }catch(Exception e){
            e.printStackTrace();
            retry++;
            if(retry>=2){
                return "failed";
            }
            return getAnswer(userInput, conversationId);
        }
    }

    private static String getAnswer(String userInput, String conversationId) {
        JSONObject json = new JSONObject();
        json.put("app_id", "454b1634-91ad-4dde-9d2f-f9a3302fdcbe");
        json.put("conversation_id", conversationId);
        json.put("query", userInput);
        json.put("stream", false);

        HttpRequest request = HttpUtil.createRequest(Method.POST, "https://qianfan.baidubce.com/v2/app/conversation/runs")
                .header("X-Appbuilder-Authorization", "Bearer bce-v3/ALTAK-MyGbNEA18oT3boS2nOga1/d8b5057f7842f59b2c64971d8d077fe724d0aed5")
                .header("Content-Type", "application/json")
                .body(json.toJSONString()).timeout(120*1000);
        ;
        long l = System.currentTimeMillis();
        String resposne = request.execute().body();
        System.out.println((System.currentTimeMillis() - l) / 1000 + userInput);
        String answer = JSONObject.parseObject(resposne).getString("answer");
        return answer == null ? "" : answer;
    }


    public static String getConversationId() {
        JSONObject json = new JSONObject();
        json.put("app_id", "454b1634-91ad-4dde-9d2f-f9a3302fdcbe");
        HttpRequest request = HttpUtil.createRequest(Method.POST, "https://qianfan.baidubce.com/v2/app/conversation")
                .header("X-Appbuilder-Authorization", "Bearer bce-v3/ALTAK-MyGbNEA18oT3boS2nOga1/d8b5057f7842f59b2c64971d8d077fe724d0aed5")
                .header("Content-Type", "application/json")
                .body(json.toJSONString());
        ;
        String resposne = request.execute().body();
        return JSONObject.parseObject(resposne).getString("conversation_id");
    }

    public static String fileName = "C:\\Users\\17664\\Desktop\\knowleges"+System.currentTimeMillis()+".xlsx";
    static HSSFWorkbook  workbook;
    public static void main(String[] args) {
        String conversationId = getConversationId();
        String accessToken = BaidubceUtil.getAccessToken();
        //System.out.println(getChatResponse("你是谁?",conversationId));
        /*String diseaseStr = "高血压； 冠心病； 房颤； 心力衰竭； 低血压； 心肌缺血； 心肌炎； 心绞痛； 窦性心动过缓； 急性心肌梗死； 高脂血症； 肺栓塞； 肺动脉高压； 动脉粥样硬化； 窦性心动过速； 卵圆孔未闭； 预激综合征； 心包积液； 扩张型心肌病； 室上性心动过速； 室间隔缺损； 肺水肿； 高同型半胱氨酸血症； 动脉导管未闭； 急性冠脉综合征； 肥厚型心肌病； 肺源性心脏病； 房室传导阻滞； 高血压危象； 二尖瓣关闭不全； 病态窦房结综合征； 主动脉瓣关闭不全； 二尖瓣狭窄； 高血压性心脏病； 室性心动过速； 二尖瓣脱垂； 心包炎； 早期复极综合征； 主动脉瓣狭窄； 慢性肺源性心脏病； 静脉血栓栓塞； 心脏肥大； 主动脉瘤； 心内膜炎； 心源性水肿； 心室颤动； 血脂异常； 应激性心肌病； 主动脉夹层； 心源性晕厥";
        String[] diseases = diseaseStr.split("；");
        for(String disease:diseases) {
            if("房颤".equals(disease)){
                break;
            }
            disease = disease.trim();
            System.out.println(new QizhenAssistant().getChatResponse("你是一个医学专家，想知道"+disease+"对应的ICD-10疾病名称和编码有哪些？请根据以下要求输出JSON数组格式的结果:\n" +
                    "不需要输出json之外的其他内容！\n" +
                    "- 键 \"name\"：疾病名称，字符串类型。\n" +
                    "- 键 \"code\"：对应的ICD10编码",conversationId));
        }*/
        //String diseaseStr = "湿疹； 痤疮； 足癣/脚气； 脱发； 银屑病/牛皮癣； 特应性皮炎/AD； 甲真菌病； 带状疱疹； 梅毒； 获得性免疫缺陷综合征； 白癜风； 毛囊炎； 扁平疣； 汗疱疹； 脂肪瘤； 甲沟炎； 过敏性紫癜； 生殖器疱疹； 脂溢性皮炎； 阴虱； 玫瑰糠疹； 花斑癣； 股癣； 淋球菌感染； 神经性皮炎； 珍珠状阴茎丘疹； 日光性皮炎； 肛门瘙痒症； 丘疹性荨麻疹； 臭汗症； 丹毒； 系统性红斑狼疮； 疥疮； 鹅口疮； 斑秃； 疖； 玫瑰痤疮； 急性荨麻疹； 黑色素瘤； 胆碱能性荨麻疹； 尖锐湿疣； 慢性荨麻疹； 接触性皮炎； 肋间神经痛； 麻疹； 黄褐斑； 毛囊角化病； 传染性软疣； 白化病； 黑棘皮病";
        String diseaseStr = "带状疱疹； 梅毒； 获得性免疫缺陷综合征； 白癜风； 毛囊炎； 扁平疣； 汗疱疹； 脂肪瘤； 甲沟炎； 过敏性紫癜； 生殖器疱疹； 脂溢性皮炎； 阴虱； 玫瑰糠疹； 花斑癣； 股癣； 淋球菌感染； 神经性皮炎； 珍珠状阴茎丘疹； 日光性皮炎； 肛门瘙痒症； 丘疹性荨麻疹； 臭汗症； 丹毒； 系统性红斑狼疮； 疥疮； 鹅口疮； 斑秃； 疖； 玫瑰痤疮； 急性荨麻疹； 黑色素瘤； 胆碱能性荨麻疹； 尖锐湿疣； 慢性荨麻疹； 接触性皮炎； 肋间神经痛； 麻疹； 黄褐斑； 毛囊角化病； 传染性软疣； 白化病； 黑棘皮病";
        String[] diseases = diseaseStr.split("；");

        workbook = new HSSFWorkbook();//这里也可以设置sheet的Name
        HSSFSheet sheet = workbook.createSheet("皮肤科");;//工作表
        int rows = 0;
        //for(String disease:diseases){
            List<Knowlege> data = getData(conversationId, accessToken, "带状疱疹");
            if(!CollectionUtils.isEmpty(data)) {
                for (Knowlege temp:data) {
                    HSSFRow row = sheet.createRow(rows++);
                    row.createCell(0).setCellValue(temp.getEntity() == null ? "" : temp.getEntity());
                    row.createCell(1).setCellValue(temp.getProperty() == null ? "" : temp.getProperty());
                    row.createCell(2).setCellValue(temp.getValue() == null ? "" : temp.getValue());
                    row.createCell(3).setCellValue(temp.getText() == null ? "" : temp.getText());
                    row.createCell(4).setCellValue(temp.getIcd10() == null ? "" : temp.getIcd10());
                }
            }
            save();
        //}
    }

    private static synchronized void save() {
        try {
            //文档输出
            FileOutputStream out = new FileOutputStream(new File(fileName));
            workbook.write(out);
            out.close();
            System.out.println(fileName + "存储完毕");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static List<Knowlege> getData(String conversationId, String accessToken,String disease) {
        List<Knowlege> list = new ArrayList<>();
        try {
            QizhenAssistant qizhenAssistant = new QizhenAssistant();
            BaidubceUtil baidubceUtil = new BaidubceUtil();
            String propertyStr = "标准通用名称" +
                    ",ICD-10编码" +
                    ",ICD-10临床版编码" +
                    ",ICD-10医保版编码" +
                    ",别名" +
                    ",所属科室" +
                    ",疾病大类" +
                    ",疾病分类" +
                    ",发病率" +
                    ",患病率" +
                    ",感染率" +
                    ",传播途径" +
                    ",是否传染病" +
                    ",是否具有传染性" +
                    ",疾病高发地区" +
                    ",传染病高发地区" +
                    ",传染源" +
                    ",易患人群" +
                    ",高危人群" +
                    ",症状" +
                    ",主要症状" +
                    ",伴随症状" +
                    ",常见症状" +
                    ",少见症状" +
                    ",病因" +
                    ",诱因" +
                    ",危险因素" +
                    ",体征" +
                    ",常见体征" +
                    ",少见体征" +
                    ",严重程度" +
                    ",发生部位" +
                    ",鉴别诊断疾病" +
                    ",与[变应性鼻炎]的鉴别诊断" +
                    ",与[鉴别诊断疾病]的鉴别诊断" +
                    ",并发症" +
                    ",合并症" +
                    ",相关检查" +
                    ",主要体格检查项目" +
                    ",相关检验项目" +
                    ",相关辅助检查" +
                    ",相关影像学检查" +
                    ",诊断标准" +
                    ",疾病分型" +
                    ",相关评估量表" +
                    ",治疗方式" +
                    ",预防性治疗" +
                    ",预防" +
                    ",药物治疗" +
                    ",抗病毒药物治疗" +
                    ",抗菌药物治疗" +
                    ",解热镇痛抗炎治疗" +
                    ",中药治疗>>中成药" +
                    ",中药治疗>>中药方剂" +
                    ",手术操作治疗" +
                    ",手术指征" +
                    ",一般治疗" +
                    ",护理方式" +
                    ",诊疗指南" +
                    ",临床路径" +
                    ",文献" +
                    ",专家共识" +
                    ",知识来源";

            String[] properties = propertyStr.split(",");
            disease = disease.trim();
   /*         String icd10Json = qizhenAssistant.getChatResponse("你是一个医学专家，想知道" + disease + "对应的ICD-10疾病名称和编码是什么？请根据以下要求输出JSON数组格式的结果:\n" +
                    "不需要输出json之外的其他内容！\n" +
                    "只根据知识库里的知识回答，不要发散！没有找到相应的内容，则返回为空字符串。\n" +
                    "- 键 \"name\"：疾病名称，字符串类型。\n" +
                    "- 键 \"code\"：对应的ICD10编码", conversationId);
            String icd10 = filte(icd10Json);*/
            for (String property : properties) {
                try {
                    property = property.trim();
                    String q = "你是一个皮肤科的医生。请回答：" + disease + "有哪些" + property + "?\n请按如下要求回答：\n" +
                            "- 只根据知识库里的知识回答，不要发散！";
                            //"\n- 没有找到相应的知识，则返回\"未找到相关知识\"!";

                    String answer = qizhenAssistant.getChatResponse(q, conversationId);
                    String chatResponse = "";
                    if (!"failed".equals(answer)) {
                        String tiqu = "你是一个医学专业的关系抽取专家。需要从文本中提取" + disease + "的" + property + "，请输出JSON数组格式的结果,不需要输出json之外的其他内容！如果有描述信息按如下要求输出：" +
                                "\n" +
                                "- 键 \"name\"：对应的" + property + "，字符串类型。\n" +
                                "- 键 \"description\"：对应的" + property + "的描述信息；如果没有，请使用空字符串。" +
                                "\n\n文本内容如下：\n\n" + answer;
                        chatResponse = baidubceUtil.getChatResponse(tiqu, accessToken);
                        chatResponse = filte(chatResponse);
                        System.out.println(chatResponse);
                    }
                    Knowlege knowlege = new Knowlege();
                    knowlege.setEntity(disease);
                    knowlege.setProperty(property);
                    knowlege.setValue(chatResponse);
                    knowlege.setText(answer);
                    //knowlege.setIcd10(icd10);
                    list.add(knowlege);
                }catch (Exception e){
                    System.out.println("抽取三元组失败！");
                    e.printStackTrace();
                }
            }
            return list;
        } catch (Exception e) {
            System.out.println("未知错误！");
            e.printStackTrace();
        }finally {
            return list;
        }
    }

    private static List<Knowlege> getData2(String conversationId, String accessToken) {
        try {
            String diseaseStr = "高血压,冠心病,房颤,心力衰竭,低血压,心肌缺血,心肌炎,心绞痛,窦性心动过缓,急性心肌梗死,高脂血症,肺栓塞,肺动脉高压,动脉粥样硬化,窦性心动过速,卵圆孔未闭,预激综合征,心包积液,扩张型心肌病,室上性心动过速,室间隔缺损,肺水肿,高同型半胱氨酸血症,动脉导管未闭,急性冠脉综合征,肥厚型心肌病,肺源性心脏病,房室传导阻滞,高血压危象,二尖瓣关闭不全,病态窦房结综合征,主动脉瓣关闭不全,二尖瓣狭窄,高血压性心脏病,室性心动过速,二尖瓣脱垂,心包炎,早期复极综合征,主动脉瓣狭窄,慢性肺源性心脏病,静脉血栓栓塞,心脏肥大,主动脉瘤,心内膜炎,心源性水肿,心室颤动,血脂异常,应激性心肌病,主动脉夹层,心源性晕厥";
            QizhenAssistant qizhenAssistant = new QizhenAssistant();
            BaidubceUtil baidubceUtil = new BaidubceUtil();
            String propertyStr = "诊疗操作" +
                    ",治疗方案" +
                    ",诊断标准" +
                    ",治疗目标" +
                    ",治疗方式" +
                    ",治疗相关检查" +
                    ",致病原因" +
                    ",治疗原则" +
                    ",诊疗依据" +
                    ",治疗场所" +
                    ",子类" +
                    ",治疗器械" +
                    ",治疗药物" +
                    ",转出重症病房标准" +
                    ",诊断相关检查" +
                    ",症状";

            String[] diseases = diseaseStr.split("；");
            String[] properties = propertyStr.split(",");
            List<Knowlege> list = new ArrayList<>();
            for (String disease : diseases) {
                disease = disease.trim();
                String icd10Json = qizhenAssistant.getChatResponse("你是一个医学专家，想知道" + disease + "对应的ICD-10疾病名称和编码是什么？请根据以下要求输出JSON数组格式的结果:\n" +
                        "不需要输出json之外的其他内容！\n" +
                        "- 键 \"name\"：疾病名称，字符串类型。\n" +
                        "- 键 \"code\"：对应的ICD10编码", conversationId);
                String icd10 = filte(icd10Json);
                for (String property : properties) {
                    property = property.trim();
                    String q = "你是一个医生。想知道" + disease + "有哪些" + property + "?";
                    String answer = qizhenAssistant.getChatResponse(q, conversationId);
                    String tiqu = "你是一个医学专业的关系抽取专家。需要从文本中提取" + disease + "的" + property + "，请输出JSON数组格式的结果,不需要输出json之外的其他内容！如果有描述信息按如下要求输出：" +
                            "\n" +
                            "- 键 \"name\"：对应的" + property + "，字符串类型。\n" +
                            "- 键 \"description\"：对应的" + property + "的描述信息；如果没有，请使用空字符串。" +
                            "\n\n文本内容如下：\n\n" + answer;
                    String chatResponse = baidubceUtil.getChatResponse(tiqu, accessToken);
                    chatResponse = filte(chatResponse);
                    Knowlege knowlege = new Knowlege();
                    knowlege.setEntity(disease);
                    knowlege.setProperty(property);
                    knowlege.setValue(chatResponse);
                    knowlege.setText(answer);
                    knowlege.setIcd10(icd10);
                    list.add(knowlege);
                }
            }
            return list;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    private static List<Knowlege> getData3(String conversationId, String accessToken) {
        try {
            String diseaseStr = "哮喘,慢性支气管炎,肺癌,新型冠状病毒肺炎,肺炎,慢性阻塞性肺疾病,气胸,结核病,肺栓塞,肺动脉高压,过敏性咳嗽,气管炎,咳嗽变异性哮喘,支原体肺炎,尘肺病,胸腺瘤,流行性感冒,胸腔积液,百日咳,结节病,呼吸性碱中毒,急性支气管炎,结核性胸膜炎,呼吸衰竭,肺水肿,支气管扩张症,肺源性心脏病,肺脓肿,睡眠呼吸暂停综合征,矽肺,吸入性肺炎,急性呼吸窘迫综合征,间质性肺病,病毒性肺炎,机化性肺炎,人感染禽流感,放射性肺炎,乳糜胸,细菌性肺炎,胸膜间皮瘤,心源性哮喘,韦格纳肉芽肿,肺泡蛋白沉积症,特发性肺纤维化,衣原体肺炎,淋巴管肌瘤病,肺曲菌病,隐球菌病,呼吸性酸中毒,肺吸虫病";
            QizhenAssistant qizhenAssistant = new QizhenAssistant();
            BaidubceUtil baidubceUtil = new BaidubceUtil();
            String propertyStr = "诊疗操作" +
                    ",治疗方案" +
                    ",诊断标准" +
                    ",治疗目标" +
                    ",治疗方式" +
                    ",治疗相关检查" +
                    ",致病原因" +
                    ",治疗原则" +
                    ",诊疗依据" +
                    ",治疗场所" +
                    ",子类" +
                    ",治疗器械" +
                    ",治疗药物" +
                    ",转出重症病房标准" +
                    ",诊断相关检查" +
                    ",症状";

            String[] diseases = diseaseStr.split("；");
            String[] properties = propertyStr.split(",");
            List<Knowlege> list = new ArrayList<>();
            for (String disease : diseases) {
                disease = disease.trim();
                String icd10Json = qizhenAssistant.getChatResponse("你是一个医学专家，想知道" + disease + "对应的ICD-10疾病名称和编码是什么？请根据以下要求输出JSON数组格式的结果:\n" +
                        "不需要输出json之外的其他内容！\n" +
                        "- 键 \"name\"：疾病名称，字符串类型。\n" +
                        "- 键 \"code\"：对应的ICD10编码", conversationId);
                String icd10 = filte(icd10Json);
                for (String property : properties) {
                    property = property.trim();
                    String q = "你是一个医生。想知道" + disease + "有哪些" + property + "?";
                    String answer = qizhenAssistant.getChatResponse(q, conversationId);
                    String tiqu = "你是一个医学专业的关系抽取专家。需要从文本中提取" + disease + "的" + property + "，请输出JSON数组格式的结果,不需要输出json之外的其他内容！如果有描述信息按如下要求输出：" +
                            "\n" +
                            "- 键 \"name\"：对应的" + property + "，字符串类型。\n" +
                            "- 键 \"description\"：对应的" + property + "的描述信息；如果没有，请使用空字符串。" +
                            "\n\n文本内容如下：\n\n" + answer;
                    String chatResponse = baidubceUtil.getChatResponse(tiqu, accessToken);
                    chatResponse = filte(chatResponse);
                    Knowlege knowlege = new Knowlege();
                    knowlege.setEntity(disease);
                    knowlege.setProperty(property);
                    knowlege.setValue(chatResponse);
                    knowlege.setText(answer);
                    knowlege.setIcd10(icd10);
                    list.add(knowlege);
                }
            }
            return list;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    private static String filte(String chatResponse) {
        if (chatResponse.startsWith("```json")) {
            chatResponse = chatResponse.substring(7);
        }
        if (chatResponse.endsWith("```")) {
            chatResponse = chatResponse.substring(0, chatResponse.length() - 3);
        }
        return chatResponse;
    }


}
